SystemOrganization addCategory: #'Mocketry-Proxy'!
SystemOrganization addCategory: #'Mocketry-Core'!
SystemOrganization addCategory: #'Mocketry-StateSpecs'!
SystemOrganization addCategory: #'Mocketry-ContextSpecs'!
SystemOrganization addCategory: #'Mocketry-UsageSpecs'!
SystemOrganization addCategory: #'Mocketry-Actions'!
SystemOrganization addCategory: #'Mocketry-SyntaxSugar'!
SystemOrganization addCategory: #'Mocketry-SpecDSL'!
SystemOrganization addCategory: #'Mocketry-Help'!

!Number methodsFor: '*Mocketry-StateSpecs-specs' stamp: 'dik 14.2.08 21:39'!
isEqual: aNumber within: accuracy 
	^(self - aNumber) abs < accuracy! !

!BlockNode methodsFor: '*Mocketry-Core' stamp: 'dik 2/17/2008 21:24'!
arguments	
	^arguments! !

Error subclass: #SpecFailed
	instanceVariableNames: 'reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!SpecFailed class methodsFor: 'instance creation' stamp: 'dk 8/17/2007 17:53'!
raiseWith: aValidationFailing 
	(self withReason: aValidationFailing) signal! !

!SpecFailed class methodsFor: 'instance creation' stamp: 'dk 8/17/2007 17:53'!
withReason: aValidationFailing 
	^self new reason: aValidationFailing! !

!SpecFailed methodsFor: 'private - actions' stamp: 'dk 8/17/2007 18:12'!
defaultAction
	^reason debugSpecOver: self! !

!SpecFailed methodsFor: 'displaying' stamp: 'dk 8/17/2007 16:24'!
description
	^ self class name , ': ' , reason description! !

!SpecFailed methodsFor: 'accessing' stamp: 'dk 8/17/2007 16:24'!
reason
	^ reason! !

!SpecFailed methodsFor: 'accessing' stamp: 'dk 8/17/2007 16:24'!
reason: anObject
	reason := anObject! !

!SpecFailed methodsFor: 'private - accessing' stamp: 'dk 8/17/2007 18:46'!
signalContext
	^signalContext! !

Error subclass: #UnexpectedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SyntaxSugar'!

!String methodsFor: '*mocketry-displaying' stamp: 'dik 6/28/2010 01:28'!
stringForSpecTitle
	^self printString! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 01:26'!
argumentNames

	| decompile |
	decompile := self decompile.
	decompile ifNotNil: [^decompile arguments collect: [:eachArgNode | eachArgNode name]].
	
	^(1 to: numArgs) collect: [:i | 'arg', i printString ]
	! !

!BlockClosure methodsFor: '*mocketry-Actions' stamp: 'dik 5/23/2010 00:28'!
asMockAction
	^PluggableMockAction basedOn: self! !

!BlockClosure methodsFor: '*mocketry-StateSpecs' stamp: 'dik 10/1/2010 11:56'!
asStateSpec

	^ArbitraryStateSpec from: self! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 00:26'!
define: aSpecClass 
	(SpecBuilding 
		class: aSpecClass
		by: self
		in: thisContext) run! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 00:27'!
lenientSpec
	self define: LenientBehaviorSpec! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 00:27'!
runScenario
	(Scenario definedBy: self) run! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 00:27'!
strictSpec
	self define: StrictBehaviorSpec! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 5/23/2010 00:48'!
stringForSpecTitle
	^self decompile printString ! !

!BlockClosure methodsFor: '*mocketry-core' stamp: 'dik 9/30/2010 17:46'!
stringForSpecValidation
	^self decompile decompileString! !

!Pragma class methodsFor: '*Mocketry-SyntaxSugar-finding' stamp: 'dik 2/17/2008 20:14'!
allSyntaxInMethod: aMethod 
	^aMethod pragmas select: [:each | each keyword == #syntax:]! !

!Pragma methodsFor: '*Mocketry-SyntaxSugar' stamp: 'dik 2/17/2008 20:01'!
clause
	^arguments first! !

!Pragma methodsFor: '*Mocketry-SyntaxSugar' stamp: 'dik 2/17/2008 20:18'!
createInstanceWith: anArray 
	^self methodClass soleInstance perform: self selector
		withArguments: anArray! !

!Collection methodsFor: '*mocketry-SyntaxSugar' stamp: 'dik 6/21/2010 10:57'!
stringForSpecTitle
	^String streamContents: [:s | 
		
		self printNameOn: s.
		s nextPut: $(.
		self do: [:element | element stringForSpecTitle] separatedBy: [s space].
		s nextPut: $)
		]! !

CustomHelp subclass: #MocketryHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Help'!

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:28'!
actions
	^ HelpTopic 
		title: 'Actions'
		contents:
'mock someMessage willReturn: ''someObject''.
mock someMessage will: [2 + 3].
(mock someMessageWith: Any) will: [:arg | arg + 4]'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:25'!
argumentConstraintsDSL
	^ HelpTopic 
		title: 'Argument constraints DSL'
		contents:
'mock someMessageWith: Any.
mock messageWith: ''concrete object''.
mock messageWith: (Kind of: Integer).
mock messageWith: (Equal to: 10.222 within: 0.01)
mock messageWith: (Satisfying for: [:arg | arg > 0])
mock messageWith: (Instance of: Float) & (Satisfying for: [:arg | arg > 10]).
mock messageWith: (Satisfying for: [:arg | arg > 10]) | (Satisfying for: [:arg | arg < 100]).'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:24'!
behaviorSpecifications
	^ HelpTopic 
		title: 'Behavior specifications'
		contents:
'- ordered behavior:

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2]
   should strictly satisfy:
[mock1 someMessage willReturn: ''some''.
 mock2 someMessage2]]
	runScenario

	
- unordered behavior:

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2]
   should lenient satisfy:
[mock2 someMessage2.
 mock1 someMessage willReturn: ''some'']]
	runScenario
	
	
- ordered behavior with raising exception spec:

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2. ZeroDivide signal]
   should raise: ZeroDivide andStrictlySatisfy:
[mock1 someMessage willReturn: ''some''.
 mock2 someMessage2]]
	runScenario

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2]
   should not raise: ZeroDivide andStrictlySatisfy:
[mock1 someMessage willReturn: ''some''.
 mock2 someMessage2]]
	runScenario
	
	
- unordered behavior with raising exception spec:

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2. ZeroDivide signal]
   should raise: ZeroDivide andLenientSatisfy:
[mock2 someMessage2.
 mock1 someMessage willReturn: ''some'']]
	runScenario

[:mock1 :mock2 | [mock1 someMessage. mock2 someMessage2]
   should not raise: ZeroDivide andLenientSatisfy:
[mock2 someMessage2.
 mock1 someMessage willReturn: ''some'']]
	runScenario'! !

!MocketryHelp class methodsFor: 'accessing' stamp: 'LaurentLaffont 11/29/2010 21:36'!
bookName
	^ 'Mocketry'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:27'!
messageSendUsageRules
	^ HelpTopic 
		title: 'Message send usage rules'
		contents:
'mock someMessage useArbitrary
mock someMessage useOnce
mock someMessage useAtLeast: 3
mock someMessage useAtMost: 5'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:21'!
overview
	^ HelpTopic 
		title: 'Overview'
		contents:
'Mocketry is smalltalk mock object framework based on specifications.
It support all kind specifications for object interactions:
- arguments constraint
- context specs
- actions
- usage specs
- ordering messages.

Behavior specs build by pure message sends to mock objects and has full refactoring support.

Mock objects implements some special proxy mechanizm for support development tools (debugging).

Mocketry implements "scenario system" that allows transparent access to mock objects. If you need mock object just get it in scenario block argument:
[:mockA :mockB |
	"some set up code"

	[mockA someMessageWith: 20.
	mockB someMessage2] 
		should strictly satisfy:  
	[mockA someMessageWith: (Kind of: Integer).
	mockB someMessage2 willReturn: #someValue].

	"maybe some assertions: 
		var should be: true. 
		... "
] runScenario.

First block here is tested behavior. Second - expected message sends.
Or you can create MockObject instance variable in setUp method: "some := MockObject new". And you get mock object named ''some'' in your "scenario tests".

Mocketry provide special SSpec-like extended DSL for all kind of specifications (state and behavior).

  10 should be an instance of: SmallInteger
  [ZeroDivide raiseSignal] should raise: ZeroDivide.
  ...
  [mockA someMessage] should lenient satisfy: [mockA someMessage]
  ...

Package Mocketry-SpecDSL shows how create new DSL clauses based on pragmas.
See examples in acceptance tests.'! !

!MocketryHelp class methodsFor: 'accessing' stamp: 'LaurentLaffont 11/29/2010 21:30'!
pages
	^ #(overview 
		behaviorSpecifications 
		argumentConstraintsDSL
		specificationsOnMessageContext
		messageSendUsageRules
		actions
		stateSpecDSL
		stateSpecDSLPragmas
		)! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:26'!
specificationsOnMessageContext
	^ HelpTopic 
		title: 'Specifications on message context'
		contents:
'mock someMessage when: [someObject] is: ''state spec or concrete object''	
mock someMessage when: [someObject] is: (Kind of: Number)
mock someMessage when: [someObject] satisfy: [:anObject | true or: false].
mock someMessage shouldBeAsynchronous'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:28'!
stateSpecDSL
	^ HelpTopic 
		title: 'StateSpec DSL'
		contents:
'5 should equals: 5
5 should be an instance of: SmallInteger
[1 / 0] should raise: ZeroDivide
6 should not equals: 5
5.0 should not be an instance of: SmallInteger
[1 / 1] should not raise: ZeroDivide'! !

!MocketryHelp class methodsFor: 'pages' stamp: 'LaurentLaffont 11/29/2010 21:31'!
stateSpecDSLPragmas
	^ HelpTopic 
		title: 'StateSpec DSL implemented based on pragmas:'
		contents:
'Instance>>of: aClass
  syntax: #(be an instance of: )>
  syntax: #(be instance of: )>
  ^ClassSpec for: aClass

And you can write both expressions:

 4 should be an instance of: SmallInteger
 4 should be instance of: SmallInteger'! !

!ContextPart methodsFor: '*Mocketry-SyntaxSugar-accessing' stamp: 'dik 14.2.08 21:40'!
arguments
	^(1 to: self method numArgs) collect: [:index | self tempAt: index]! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 2/17/2008 21:38'!
argumentNames
	^self decompile arguments collect: [:eachArgNode | eachArgNode name]! !

!BlockContext methodsFor: '*Mocketry-Actions' stamp: 'dik 14.2.08 21:40'!
asMockAction
	^PluggableMockAction basedOn: self! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 14.2.08 21:38'!
define: aSpecClass 
	(SpecBuilding 
		class: aSpecClass
		by: self
		in: thisContext) run! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 14.2.08 21:38'!
lenientSpec
	self define: LenientBehaviorSpec! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 14.2.08 21:38'!
runScenario
	(Scenario definedBy: self) run! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 14.2.08 21:38'!
strictSpec
	self define: StrictBehaviorSpec! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 2/17/2008 21:14'!
stringForSpecTitle
	^self decompileString ! !

!BlockContext methodsFor: '*Mocketry-Core' stamp: 'dik 2/17/2008 21:20'!
stringForSpecValidation
	^self decompileString ! !

!Point methodsFor: '*Mocketry-StateSpecs-specs' stamp: 'dik 14.2.08 21:39'!
isEqual: aPoint within: accuracy 
	^(self dist: aPoint) < accuracy! !

ProtoObject subclass: #MocketryProxy
	instanceVariableNames: 'devServices helper name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Proxy'!

!MocketryProxy commentStamp: '<historical>' prior: 0!
This is minimal behavior for any proxy object.
It prevent inspecting and support usual printing for debuging.
It defines class  in #xxxclass method.

Concrete proxy class must specify behavior in #doesNotUnderstand: message.
And it can implement special printing capabilities in method #xxxprintProxyName.
And it can implement special inspecting (Now inspecting is prevented by empty #inspect method)!

MocketryProxy subclass: #MockObject
	instanceVariableNames: 'behaviorSpecHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Proxy'!

!MockObject methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	^behaviorSpecHandler evaluateMessageSend: (MessageSend 
				receiver: self
				selector: aMessage selector
				arguments: aMessage arguments)! !

!MockObject methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxbehaviorSpecHandler
	^behaviorSpecHandler! !

!MockObject methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxbehaviorSpecHandler: aBehaviorSpecHandler 
	behaviorSpecHandler := aBehaviorSpecHandler! !

!MocketryProxy class methodsFor: 'test' stamp: 'dik 2/17/2008 22:07'!
customTest
	"
	self customTest
	"

	| p |
	self halt.
	p := MocketryProxy named: 'This is proxy'.
	^ p! !

!MocketryProxy class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
helperObject
	^ProxyHelper! !

!MocketryProxy class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
helperObjectFor: aProxy 
	^self helperObject for: aProxy! !

!MocketryProxy class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
named: aString 
	^self new xxxname: aString! !

!MocketryProxy class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
new
	^super new xxxinitialize! !

!MocketryProxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
= anObject 
	"Answer whether the receiver and the argument represent the same object.
	If = is redefined in any subclass, consider also redefining the message hash."

	^self == anObject! !

!MocketryProxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
== anObject
	"Answer true if the receiver and the argument are the same object (have the 
	same object pointer) and false otherwise."

	<primitive: 110>
	nil primitiveFailed! !

!MocketryProxy methodsFor: 'specs' stamp: 'dk 16.8.07 17:18'!
asConstraint
	^Equal for: self! !

!MocketryProxy methodsFor: 'specs' stamp: 'dik 14.2.08 21:39'!
asStateSpec
	^EqualitySpec pattern: self! !

!MocketryProxy methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
doesNotUnderstand: aMessage 
	"This message for dispatch mechanism framework"

	(devServices isActiveIn: thisContext) 
		ifTrue: [^helper evaluateMessage: aMessage].
	^self evaluateMessage: aMessage! !

!MocketryProxy methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	nil subclassResponsibility! !

!MocketryProxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
hash
	^self identityHash! !

!MocketryProxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
identityHash
	"See the method comment in class Object."

	<primitive: 75>
	nil primitiveFailed! !

!MocketryProxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNil: aBlock
	"Return the receiver if it is not nil, or evaluate the block
	and return the result if the receiver is nil."

	^self! !

!MocketryProxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNil: nilBlock ifNotNil: notNilBlock
	"If the receiver is not nil, answer the evaluation of aBlock (with the receiver as
	 its argument if it takes one), otherwise answer nil.
	 UndefinedObject redefines this to answer the evaluation of nilBlock, and hence
	 since here the receiver is not nil answer the evaluation of notNilBlock."

	^0 == notNilBlock numArgs
		ifTrue: [notNilBlock value]
		ifFalse: [notNilBlock value: self]! !

!MocketryProxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNotNil: aBlock
	"If the receiver is not nil, answer the evaluation of aBlock (with the receiver as
	 its argument if it takes one), otherwise answer nil.  Since the receiver is not nil,
	 answer aBlock's evaluation.  Passing the receiver to aBlock is handy for idioms
	 such as
		self toolBarSpec ifNotNil: [:spec | ...].
	UndefinedObject reimplements this to not evaluate aBlock."

	^0 == aBlock numArgs
		ifTrue: [aBlock value]
		ifFalse: [aBlock value: self]! !

!MocketryProxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNotNil: notNilBlock ifNil: nilBlock
	"If the receiver is not nil, answer the evaluation of notNilBlock (with the
	 receiver as its argument if it takes one), otherwise answer the evaluation
	 of nilBlock.  UndefinedObject redefines this to answer the evaluation of nilBlock,
	 and hence since here the receiver is not nil answer the evaluation of notNilBlock."

	^0 == notNilBlock numArgs
		ifTrue: [notNilBlock value]
		ifFalse: [notNilBlock value: self]! !

!MocketryProxy methodsFor: 'local variables' stamp: 'dik 9/3/2007 17:09'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>

	^nil primitiveFailed ! !

!MocketryProxy methodsFor: 'local variables' stamp: 'dik 9/3/2007 17:09'!
instVarAt: index put: anObject
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 74>

	^nil primitiveFailed! !

!MocketryProxy methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
isEqual: anObject 
	^self = anObject! !

!MocketryProxy methodsFor: 'testing' stamp: 'dik 6/21/2010 10:50'!
isLiteral
	^false! !

!MocketryProxy methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isNil
	^false! !

!MocketryProxy methodsFor: 'testing' stamp: 'dik 6/21/2010 10:52'!
isSelfEvaluating
	^false! !

!MocketryProxy methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
notNil
	^true! !

!MocketryProxy methodsFor: 'specs' stamp: 'dik 14.2.08 21:41'!
should
	^SyntaxHelper supplyingTargetsFrom: DSLHelper
		to: (SpecValidator for: self)! !

!MocketryProxy methodsFor: 'specs' stamp: 'dik 14.2.08 21:41'!
shouldnt
	^self should not! !

!MocketryProxy methodsFor: 'specs' stamp: 'dk 16.8.07 17:18'!
specOfEqualityFor: anObject 
	^EqualitySpec pattern: anObject! !

!MocketryProxy methodsFor: 'printing' stamp: 'dik 6/6/2010 22:24'!
stringForSpecTitle
	^helper printString ! !

!MocketryProxy methodsFor: 'class membership' stamp: 'dk 16.8.07 17:16'!
xxxclass
	"Answer the object which is the receiver's class."

	<primitive: 111>
	nil primitiveFailed! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxdevServices
	^devServices! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxdevServices: aDevelopmentServices 
	devServices := aDevelopmentServices.
	aDevelopmentServices proxy: self! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxhelper
	^helper! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxhelper: aProxyHelper 
	helper := aProxyHelper! !

!MocketryProxy methodsFor: 'initialize-realize' stamp: 'dk 16.8.07 17:16'!
xxxinitialize
	devServices := DevelopmentServices currentFor: self.
	helper := self xxxclass helperObjectFor: self! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxname
	^name! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxname: aString 
	name := aString! !

!MocketryProxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
yourself! !

Object subclass: #DSLHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SyntaxSugar'!

DSLHelper subclass: #Containing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Containing class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
index: aNumber 
	<syntax: #(include index:)>
	^IndexContainmentSpec requiredIndex: aNumber! !

!Containing class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
item: anObject 
	<syntax: #(include:)>
	^ElementContainmentSpec requiredElement: anObject! !

!Containing class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
key: anObject 
	<syntax: #(include key:)>
	^KeyContainmentSpec requiredKey: anObject! !

!DSLHelper class methodsFor: 'helpers' stamp: 'dik 14.2.08 21:40'!
return: aSpec 
	"put to aSpec title from first syntax pragma"

	^aSpec
		titleFrom: (SyntaxPath allAt: thisContext sender) first;
		yourself! !

!DSLHelper class methodsFor: 'pragmas' stamp: 'dik 14.2.08 21:40'!
syntaxPragmaDefinition
	<pragmas: #class>
	^#(#syntax:)! !

DSLHelper subclass: #Equal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Equal class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
to: anObject 
	<syntax: #(equal:)>
	<syntax: #(be equal:)>
	^self return: (EqualitySpec pattern: anObject)! !

!Equal class methodsFor: 'specs creation' stamp: 'dik 2/17/2008 21:46'!
within: aNumber to: aNumber2 
	<syntax: #(be within:of:)>
	^FloatingComparisonSpec pattern: aNumber2 accuracy: aNumber! !

DSLHelper subclass: #Has
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Has class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
length: aNumber 
	^self size: aNumber! !

!Has class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
size: aNumber 
	<syntax: #(have size:)>
	<syntax: #(have length:)>
	^ElementsCountSpec requiredValue: aNumber! !

DSLHelper subclass: #Identical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Identical class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
to: anObject 
	^IdentitySpec pattern: anObject! !

DSLHelper subclass: #Instance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Instance class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
of: aClass 
	<syntax: #(be an instance of:)>
	^ClassSpec for: aClass! !

DSLHelper subclass: #Kind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Kind class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
of: aClass 
	<syntax: #(be a kind of:)>
	^HierarchySpec for: aClass! !

DSLHelper subclass: #Lenient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Lenient class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
satisfy: specDefinitionBlock 
	<syntax: #(lenient satisfy:)>
	^GeneralBehaviorSpec definedBy: specDefinitionBlock as: LenientBehaviorSpec! !

DSLHelper subclass: #Raise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
andLenientSatisfy: specDefinitionBlock 
	<syntax: #(raise and lenient satisfy:)>
	^self exception: Error andLenientSatisfy: specDefinitionBlock! !

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
andStrictlySatisfy: specDefinitionBlock 
	<syntax: #(raise and strictly satisfy:)>
	^self exception: Error andStrictlySatisfy: specDefinitionBlock! !

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
error
	<syntax: #(raise error)>
	^self exception: Error! !

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
exception: aClass 
	<syntax: #(raise:)>
	^RaisingExceptionSpec requiredException: aClass! !

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
exception: anExceptionClass andLenientSatisfy: specDefinitionBlock 
	<syntax: #(raise:andLenientSatisfy:)>
	^GeneralBehaviorSpec 
		definedBy: specDefinitionBlock
		as: LenientBehaviorSpec
		with: anExceptionClass! !

!Raise class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
exception: anExceptionClass andStrictlySatisfy: specDefinitionBlock 
	<syntax: #(raise:andStrictlySatisfy:)>
	^GeneralBehaviorSpec 
		definedBy: specDefinitionBlock
		as: StrictBehaviorSpec
		with: anExceptionClass! !

DSLHelper subclass: #Respond
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Respond class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
to: aSelector 
	<syntax: #(respond to:)>
	^ResponsibilitySpec for: aSelector! !

DSLHelper subclass: #Satisfying
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Satisfying class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
for: aBlockContext 
	<syntax: #(satisfy:)>
	^ArbitraryStateSpec from: aBlockContext! !

!Satisfying class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
for: specDefinitionBlock as: aBehaviorSpecClass 
	<syntax: #(satisfy:as:)>
	^GeneralBehaviorSpec definedBy: specDefinitionBlock as: aBehaviorSpecClass! !

!Satisfying class methodsFor: 'specs creation' stamp: 'dik 6/13/2010 22:24'!
spec: aStateSpecOrObject 
	<syntax: #(be:)>
	aStateSpecOrObject class = MockObject ifTrue: [^Identical to: aStateSpecOrObject ].
	
	^(aStateSpecOrObject isKindOf: StateSpec) 
		ifTrue: [aStateSpecOrObject]
		ifFalse: [Identical to: aStateSpecOrObject]! !

DSLHelper subclass: #Strictly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!Strictly class methodsFor: 'specs creation' stamp: 'dik 14.2.08 21:41'!
satisfy: specDefinitionBlock 
	<syntax: #(strictly satisfy:)>
	^GeneralBehaviorSpec definedBy: specDefinitionBlock as: StrictBehaviorSpec! !

Object subclass: #DevelopmentServices
	instanceVariableNames: 'proxy classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Proxy'!

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
current
	^self new addAll: self currentSystemClasses! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
currentFor: aProxy 
	^(self current)
		proxy: aProxy;
		yourself! !

!DevelopmentServices class methodsFor: 'current system classes' stamp: 'dk 8/17/2007 15:36'!
currentSystemClasses
	^(self currentSystemEnvironment select: [:eachClassSymbol | Smalltalk includesKey: eachClassSymbol]) 
		collect: [:eachClassSymbol | Smalltalk at: eachClassSymbol]

		! !

!DevelopmentServices class methodsFor: 'current system classes' stamp: 'dik 5/23/2010 01:33'!
currentSystemEnvironment
	^#(MessageSendSpec ContextVariablesInspector  MethodStub Inspector WAWalkback Debugger )
! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
for: aProxy 
	^self new proxy: aProxy! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
new
	^super new initialize! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
onClasses: anArray 
	^self new classes: anArray! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
add: aClass 
	classes add: aClass! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
addAll: anArray 
	anArray do: [:each | self add: each]! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
classes
	^classes! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
classes: anArray 
	classes := anArray! !

!DevelopmentServices methodsFor: 'context finding' stamp: 'dk 16.8.07 17:16'!
findProxyClientContextIn: aContext 
	| proxyClientContext |
	proxyClientContext := (self findProxyContextIn: aContext) sender.
	[proxyClientContext receiver == proxy] 
		whileTrue: [proxyClientContext := proxyClientContext sender].
	^proxyClientContext! !

!DevelopmentServices methodsFor: 'context finding' stamp: 'dk 16.8.07 17:16'!
findProxyContextIn: aContext 
	^aContext receiver == proxy 
		ifTrue: [aContext]
		ifFalse: [self findProxyContextIn: aContext sender]! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
includeProxyClient: anObject 
	^classes anySatisfy: 
			[:eachServiceClass | 
			anObject = eachServiceClass or: [anObject xxxclass = eachServiceClass]]! !

!DevelopmentServices methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:16'!
initialize
	classes := OrderedCollection new! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isActiveIn: aContext 
	| proxyClientContext |
	self isEmpty ifTrue: [^false].
	proxyClientContext := self findProxyClientContextIn: aContext.
	^self isActiveInProxyClientContext: proxyClientContext! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isActiveInProxyClientContext: aContext 
	| proxyClientContext |
	proxyClientContext := aContext.
	
	[proxyClientContext notNil 
		and: [(self includeProxyClient: proxyClientContext receiver) not]] 
			whileTrue: [proxyClientContext := proxyClientContext sender].
	^proxyClientContext notNil! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isEmpty
	^classes isEmpty! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy
	^proxy! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy: aProxy 
	proxy := aProxy! !

Object subclass: #MockAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MockAction methodsFor: 'converting' stamp: 'dik 14.2.08 21:38'!
asMockAction! !

!MockAction methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:38'!
executeFor: aBehaviorAct 
	self subclassResponsibility! !

!MockAction methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
reset! !

MockAction subclass: #MockActionSequence
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MockActionSequence class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
new
	^super new initialize! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
add: aMockAction 
	actions add: aMockAction! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
contents
	^actions! !

!MockActionSequence methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:38'!
executeFor: aBehaviorAct 
	actions allButLastDo: [:eachPart | eachPart executeFor: aBehaviorAct].
	^actions notEmpty ifTrue: [actions last executeFor: aBehaviorAct]! !

!MockActionSequence methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:38'!
initialize
	actions := OrderedCollection new! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
reset
	actions do: [:each | each reset]! !

MockAction subclass: #PluggableMockAction
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Actions'!

!PluggableMockAction class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
basedOn: aBlockContext 
	^self new block: aBlockContext! !

!PluggableMockAction methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
block
	^block! !

!PluggableMockAction methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
block: anObject
	block := anObject! !

!PluggableMockAction methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:40'!
executeFor: aMessageSend 
	^block numArgs = 0 
		ifTrue: [block value]
		ifFalse: [block valueWithArguments: aMessageSend arguments]! !

MockAction subclass: #ProcessBlocking
	instanceVariableNames: 'lockCount semaphore currentLockNumber currentUnlockNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Actions'!

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
lockCount: aNumber 
	^self new lockCount: aNumber! !

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
new
	^super new initialize! !

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
singleLock
	^self lockCount: 1! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
allowLockOccur
	[self isLockOccurs] whileFalse: [Processor yield]! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
currentLockNumber
	^currentLockNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
currentLockNumber: aNumber 
	currentLockNumber := aNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
currentUnlockNumber
	^currentUnlockNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
currentUnlockNumber: aNumber 
	currentUnlockNumber := aNumber! !

!ProcessBlocking methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:40'!
executeFor: aMessageSend 
	lockCount timesRepeat: [self lock]! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
finish
	lockCount - currentUnlockNumber timesRepeat: [self unlock]! !

!ProcessBlocking methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:40'!
initialize
	semaphore := Semaphore new.
	currentLockNumber := 0.
	currentUnlockNumber := 0! !

!ProcessBlocking methodsFor: 'testing' stamp: 'dik 14.2.08 21:40'!
isLockOccurs
	^currentLockNumber > currentUnlockNumber! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
lock
	currentLockNumber := currentLockNumber + 1.
	semaphore wait! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
lockCount
	^lockCount! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
lockCount: aNumber 
	lockCount := aNumber! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
reset
	semaphore terminateProcess.
	self initialize! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
semaphore
	^semaphore! !

!ProcessBlocking methodsFor: 'private' stamp: 'dik 14.2.08 21:40'!
semaphore: aSemaphore 
	semaphore := aSemaphore! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
unlock
	self allowLockOccur.
	semaphore signal.
	currentUnlockNumber := currentUnlockNumber + 1.
	Processor yield! !

MockAction subclass: #RaisingException
	instanceVariableNames: 'exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Actions'!

!RaisingException class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
of: anExceptionClass 
	^self new exceptionClass: anExceptionClass! !

!RaisingException methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
exceptionClass
	^exceptionClass! !

!RaisingException methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
exceptionClass: anExceptionClass
	exceptionClass := anExceptionClass! !

!RaisingException methodsFor: 'evaluating' stamp: 'dik 2/17/2008 21:39'!
executeFor: aMessageSend 
	exceptionClass signal! !

MockAction subclass: #ReturnReceiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Actions'!

!ReturnReceiver methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:40'!
executeFor: aMessageSend 
	^aMessageSend receiver! !

MockAction subclass: #ReturnValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Actions'!

!ReturnValue class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
of: anObject 
	^self new value: anObject! !

!ReturnValue methodsFor: 'evaluating' stamp: 'dik 14.2.08 21:40'!
executeFor: aMessageSend 
	^value! !

!ReturnValue methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
value
	^value! !

!ReturnValue methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
value: anObject
	value := anObject! !

Object subclass: #MocketryWorld
	instanceVariableNames: 'mocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MocketryWorld class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
new
	^super new initialize! !

!MocketryWorld methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
addMock: aMockObject 
	mocks add: aMockObject! !

!MocketryWorld methodsFor: 'evaluation behavior' stamp: 'dik 14.2.08 21:38'!
buildSpecification: aSpec while: aBlock 
	| behaviorHandler |
	behaviorHandler := BehaviorSpecBuilder on: aSpec.
	self evaluateBehaviorBy: behaviorHandler while: aBlock! !

!MocketryWorld methodsFor: 'objects creation' stamp: 'dik 14.2.08 21:38'!
createObjectNamed: aString 
	| newMock |
	newMock := MockObject named: aString.
	self addMock: newMock.
	^newMock! !

!MocketryWorld methodsFor: 'evaluation behavior' stamp: 'dik 14.2.08 21:38'!
evaluateBehaviorBy: behaviorHandler while: aBlock 
	| oldHandlers |
	oldHandlers := mocks 
				collect: [:eachMock | eachMock xxxbehaviorSpecHandler].
	mocks do: [:eachMock | eachMock xxxbehaviorSpecHandler: behaviorHandler].
	aBlock value.
	mocks with: oldHandlers
		do: [:eachMock :eachHandler | eachMock xxxbehaviorSpecHandler: eachHandler]! !

!MocketryWorld methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:38'!
initialize
	mocks := OrderedCollection new! !

!MocketryWorld methodsFor: 'objects accessing' stamp: 'dik 14.2.08 21:38'!
objectNamed: aString 
	^mocks detect: [:eachMock | eachMock xxxname = aString]
		ifNone: [self error: 'mock object ' , aString printString , ' is not exists']! !

!MocketryWorld methodsFor: 'objects accessing' stamp: 'dik 14.2.08 21:38'!
objects
	^mocks asArray! !

!MocketryWorld methodsFor: 'evaluation behavior' stamp: 'dik 14.2.08 21:38'!
validateSpecification: aBehaviorSpec while: aBlock 
	| specValidator |
	specValidator := MessageSendValidator on: aBehaviorSpec.
	self evaluateBehaviorBy: specValidator while: aBlock! !

!Object class methodsFor: '*Mocketry-SyntaxSugar-extracting pragmas' stamp: 'dik 14.2.08 21:40'!
syntaxPragmas
	| syntaxPragmas |
	syntaxPragmas := OrderedCollection 
				withAll: (Pragma allNamed: #syntax: in: self class).
	self allSubclassesDo: 
			[:eachSubclass | 
			syntaxPragmas addAll: (Pragma allNamed: #syntax: in: eachSubclass class)].
	^syntaxPragmas! !

!Object methodsFor: '*Mocketry-StateSpecs-converting' stamp: 'dik 14.2.08 21:39'!
asStateSpec
	^EqualitySpec pattern: self! !

!Object methodsFor: '*Mocketry-StateSpecs-testing' stamp: 'dik 14.2.08 21:39'!
isEqual: anObject 
	^self = anObject! !

!Object methodsFor: '*Mocketry-SpecDSL-specs' stamp: 'dik 14.2.08 21:41'!
should
	^SyntaxHelper supplyingTargetsFrom: DSLHelper
		to: (SpecValidator for: self)! !

!Object methodsFor: '*Mocketry-SpecDSL-specs' stamp: 'dik 14.2.08 21:41'!
shouldnt
	^self should not! !

!Object methodsFor: '*Mocketry-StateSpecs-printing' stamp: 'dik 14.2.08 21:39'!
stringForSpecTitle
	^self printString! !

!Object methodsFor: '*Mocketry-StateSpecs-displaying' stamp: 'dik 14.2.08 21:39'!
stringForSpecValidation
	^self printString! !

!Object methodsFor: '*Mocketry-Core-class membership' stamp: 'dik 14.2.08 21:38'!
xxxclass
	^self class! !

Object subclass: #ProxyHelper
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Proxy'!

!ProxyHelper class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
for: aProxy 
	^self new proxy: aProxy! !

!ProxyHelper methodsFor: 'evaluation' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	^self perform: aMessage selector withArguments: aMessage arguments! !

!ProxyHelper methodsFor: 'proxy inspecting' stamp: 'dk 16.8.07 17:16'!
inspect
	self subclassResponsibility! !

!ProxyHelper methodsFor: 'proxy testing' stamp: 'dk 16.8.07 17:16'!
isBlockClosure
	^false! !

!ProxyHelper methodsFor: 'proxy testing' stamp: 'dk 16.8.07 17:16'!
isBlockContext
	^false! !

!ProxyHelper methodsFor: 'proxy class membership' stamp: 'dk 16.8.07 17:16'!
isKindOf: aClass 
	^self proxyClass includesBehavior: aClass! !

!ProxyHelper methodsFor: 'proxy mockobject constraint' stamp: 'dk 16.8.07 17:16'!
matches: anObject 
	^proxy = anObject! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printOn: aStream 
	"Append to the argument aStream a sequence of characters
        that describes the receiver."

	| title |
	title := self printProxy.
	aStream 
		nextPutAll: ((title at: 1) isVowel ifTrue: ['an '] ifFalse: ['a ']).
	aStream nextPutAll: title! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxy
	^self printProxyClassName , self printProxyName! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxyClassName
	^self proxyClass name! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxyName
	self proxyName ifNil: [^''].
	^'(' , self proxyName , ')'! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printString
	"Answer a String whose characters are a description of the receiver."

	| aStream |
	aStream := WriteStream on: (String new: 16).
	self printOn: aStream.
	^aStream contents! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy
	^proxy! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy: aProxy 
	proxy := aProxy! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxyClass
	^proxy xxxclass! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxyName
	^proxy xxxname! !

Object subclass: #ScenarioStage
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

ScenarioStage subclass: #Scenario
	instanceVariableNames: 'world definingBlock spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!Scenario class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
definedBy: aBlock 
	^self new definingBlock: aBlock! !

!Scenario methodsFor: 'child stages' stamp: 'dik 14.2.08 21:38'!
acceptSpec: aSpec 
	spec := aSpec! !

!Scenario methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
createMockObjectsForArgs
	definingBlock argumentNames 
		do: [:eachArgName | world createObjectNamed: eachArgName]! !

!Scenario methodsFor: 'private' stamp: 'dik 5/23/2010 00:44'!
createMockObjectsForInstVars
	| mock scenarioHome instVar |
	scenarioHome := self findHomeIn: thisContext.
	scenarioHome class allInstVarNames keysAndValuesDo: 
			[:index :name | 
			instVar := scenarioHome instVarAt: index.
			instVar xxxclass = MockObject 
				ifTrue: 
					[instVar xxxname ifNil: [instVar xxxname: name].
					world addMock: instVar]]! !

!Scenario methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
createMocketryWorld
	world := MocketryWorld new.
	self createMockObjectsForArgs.
	self createMockObjectsForInstVars! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
definingBlock
	^definingBlock! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
definingBlock: aBlock 
	definingBlock := aBlock.
	self createMocketryWorld! !

!Scenario methodsFor: 'private' stamp: 'dik 5/23/2010 00:57'!
findHomeIn: aContext 
	| home |
	home := aContext.
	[home receiver == self] whileTrue: [home := home sender].
	[home receiver == Scenario] whileTrue: [home := home sender].
	[home receiver class == BlockClosure] whileTrue: [home := home sender].
	^home receiver! !

!Scenario methodsFor: 'running' stamp: 'dik 14.2.08 21:38'!
run
	definingBlock 
		valueWithArguments: (world objects copyFrom: 1 to: definingBlock numArgs)! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec
	^spec! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec: aBehaviorSpec 
	spec := aBehaviorSpec! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
world
	^world! !

!Scenario methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
world: aMocketryWorld 
	world := aMocketryWorld! !

!ScenarioStage class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
inContext: aContext 
	^(self new)
		findParentIn: aContext;
		yourself! !

!ScenarioStage class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
inThisContext
	^self inContext: thisContext sender! !

!ScenarioStage methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
findParentIn: aContext 
	| parentContext |
	parentContext := aContext.
	[(parent := parentContext receiver) isKindOf: ScenarioStage] 
		whileFalse: [parentContext := parentContext sender]! !

!ScenarioStage methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
parent
	^parent! !

!ScenarioStage methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
parent: aScenarioStage 
	parent := aScenarioStage! !

!ScenarioStage methodsFor: 'running' stamp: 'dik 14.2.08 21:38'!
run
	self subclassResponsibility! !

!ScenarioStage methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
world
	^parent world! !

ScenarioStage subclass: #SpecBuilding
	instanceVariableNames: 'buildingBlock spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!SpecBuilding class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
class: aSpecClass by: aBlock 
	^(self new)
		spec: aSpecClass new;
		buildingBlock: aBlock! !

!SpecBuilding class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
class: aSpecClass by: aBlock in: aContext 
	^(self class: aSpecClass by: aBlock)
		findParentIn: aContext;
		yourself! !

!SpecBuilding methodsFor: 'child stages' stamp: 'dik 14.2.08 21:38'!
acceptSpec: aSpecification 
	spec add: aSpecification! !

!SpecBuilding methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
buildingBlock
	^buildingBlock! !

!SpecBuilding methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
buildingBlock: aBlock 
	buildingBlock := aBlock! !

!SpecBuilding methodsFor: 'running' stamp: 'dik 14.2.08 21:38'!
run
	self world buildSpecification: spec while: buildingBlock.
	parent acceptSpec: spec! !

!SpecBuilding methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec
	^spec! !

!SpecBuilding methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec: aBehaviorSpec 
	spec := aBehaviorSpec! !

ScenarioStage subclass: #SpecValidation
	instanceVariableNames: 'testedBehavior raisingExceptionSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!SpecValidation class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
in: aContext 
	^(self new)
		findParentIn: aContext;
		yourself! !

!SpecValidation class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
with: anExceptionClass in: aContext 
	^(self in: aContext)
		raisingExceptionSpec: (RaisingExceptionSpec 
					requiredException: anExceptionClass);
		yourself! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
denial: aBoolean 
	raisingExceptionSpec ifNotNil: [raisingExceptionSpec denial: aBoolean]! !

!SpecValidation methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
executeBehavior
	^raisingExceptionSpec ifNil: [testedBehavior value]
		ifNotNil: [(raisingExceptionSpec validate: testedBehavior) raise]! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raisingExceptionSpec
	^raisingExceptionSpec! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raisingExceptionSpec: aRaisingExeptionSpec 
	raisingExceptionSpec := aRaisingExeptionSpec! !

!SpecValidation methodsFor: 'running' stamp: 'dik 14.2.08 21:38'!
run
	parent spec reset.
	self world validateSpecification: parent spec while: [self executeBehavior].
	parent spec checkValidity! !

!SpecValidation methodsFor: 'running' stamp: 'dik 14.2.08 21:38'!
runFor: aBlock 
	self
		testedBehavior: aBlock;
		run! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
testedBehavior
	^testedBehavior! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
testedBehavior: aBlock 
	testedBehavior := aBlock! !

!SpecValidation methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
title: aString 
	raisingExceptionSpec ifNotNil: [raisingExceptionSpec title: aString]! !

Object subclass: #SpecValidationState
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

SpecValidationState subclass: #SpecValidationFailing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

SpecValidationFailing subclass: #BehaviorSpecValidationFailing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

BehaviorSpecValidationFailing subclass: #MessageSendNotHappen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

BehaviorSpecValidationFailing subclass: #TooManyMessageSends
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

BehaviorSpecValidationFailing subclass: #UsageLimitExceeded
	instanceVariableNames: 'usageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!UsageLimitExceeded class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: aMessageSend withUsageLimit: anInteger 
	^(self for: aMessageSend) usageLimit: anInteger! !

!UsageLimitExceeded methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
usageLimit
	^usageLimit! !

!UsageLimitExceeded methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
usageLimit: anInteger 
	usageLimit := anInteger! !

BehaviorSpecValidationFailing subclass: #WrongMessageArgument
	instanceVariableNames: 'argumentIndex stateFailing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!WrongMessageArgument class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: aMessageSend index: aNumber stateFailing: aStateValidationFailing 
	^(self for: aMessageSend)
		argumentIndex: aNumber;
		stateFailing: aStateValidationFailing! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
argumentIndex
	^argumentIndex! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
argumentIndex: anObject
	argumentIndex := anObject! !

!WrongMessageArgument methodsFor: 'displaying' stamp: 'dik 14.2.08 21:38'!
description
	^'wrong arg ' , argumentIndex printString , ': ' 
		, stateFailing description! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
stateFailing
	^stateFailing! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
stateFailing: aStateValidationFailing 
	stateFailing := aStateValidationFailing! !

BehaviorSpecValidationFailing subclass: #WrongMessageReceiver
	instanceVariableNames: 'expectedReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!WrongMessageReceiver class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: aMessageSend withExpectedReceiver: anObject 
	^(self for: aMessageSend) expectedReceiver: anObject! !

!WrongMessageReceiver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
expectedReceiver
	^expectedReceiver! !

!WrongMessageReceiver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
expectedReceiver: anObject 
	expectedReceiver := anObject! !

BehaviorSpecValidationFailing subclass: #WrongMessageSelector
	instanceVariableNames: 'expectedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!WrongMessageSelector class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: aMessageSend withExpectedSelector: aSelector 
	^(self for: aMessageSend) expectedSelector: aSelector! !

!WrongMessageSelector methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
expectedSelector
	^expectedSelector! !

!WrongMessageSelector methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
expectedSelector: aSelector 
	expectedSelector := aSelector! !

BehaviorSpecValidationFailing subclass: #WrongProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-ContextSpecs'!

!SpecValidationFailing methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:17'!
debugSpecOver: aSpecFailed
	UnhandledError signalForException: aSpecFailed! !

!SpecValidationFailing methodsFor: 'displaying' stamp: 'dik 14.2.08 21:38'!
description
	^self class name! !

!SpecValidationFailing methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isFailing
	^true! !

!SpecValidationFailing methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raise
	^SpecFailed raiseWith: self! !

SpecValidationFailing subclass: #StateValidationFailing
	instanceVariableNames: 'spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!StateValidationFailing class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
spec: aStateSpec for: anObject 
	^(self for: anObject) spec: aStateSpec! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:31'!
debugSpecOver: aSpecFailed
	spec debugValidationFailingOver: aSpecFailed! !

!StateValidationFailing methodsFor: 'displaying' stamp: 'dik 14.2.08 21:38'!
description
	^subject stringForSpecValidation , ' ' , spec description! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec
	^spec! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec: aStateSpec 
	spec := aStateSpec! !

!SpecValidationState class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: anObject 
	^self new subject: anObject! !

!SpecValidationState methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isFailing
	self subclassResponsibility! !

!SpecValidationState methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isSuccess
	^self isFailing not! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raise
	self subclassResponsibility! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
subject
	^subject! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
subject: anObject 
	subject := anObject! !

SpecValidationState subclass: #SpecValidationSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

SpecValidationSuccess subclass: #BehaviorSpecValidationSuccess
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!BehaviorSpecValidationSuccess class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
for: aMessageState withActions: aMockActionSequence 
	^(self for: aMessageState) actions: aMockActionSequence! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
actions
	^actions! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
actions: aMockActionSequence 
	actions := aMockActionSequence! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raise
	^actions executeFor: subject! !

!SpecValidationSuccess methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isFailing
	^false! !

SpecValidationSuccess subclass: #StateValidationSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!StateValidationSuccess methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
raise! !

Object subclass: #SpecValidator
	instanceVariableNames: 'subject neededNegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SpecDSL'!

!SpecValidator class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:41'!
for: anObject 
	^self new subject: anObject! !

!SpecValidator class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:41'!
new
	^super new initialize! !

!SpecValidator methodsFor: 'specs' stamp: 'dik 14.2.08 21:41'!
changeNegation
	neededNegate := neededNegate not! !

!SpecValidator methodsFor: 'private' stamp: 'dik 14.2.08 21:41'!
checkValidationOf: spec 
	spec denial: neededNegate.
	(spec validate: subject) raise! !

!SpecValidator methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:41'!
initialize
	neededNegate := false! !

!SpecValidator methodsFor: 'accessing' stamp: 'dik 14.2.08 21:41'!
neededNegate
	^neededNegate! !

!SpecValidator methodsFor: 'accessing' stamp: 'dik 14.2.08 21:41'!
neededNegate: aBoolean 
	neededNegate := aBoolean! !

!SpecValidator methodsFor: 'private' stamp: 'dik 14.2.08 21:41'!
receive: aSpec createdBy: aSyntaxPath 
	aSpec title: aSyntaxPath printSpecTitle.
	self checkValidationOf: aSpec! !

!SpecValidator methodsFor: 'accessing' stamp: 'dik 14.2.08 21:41'!
subject
	^subject! !

!SpecValidator methodsFor: 'accessing' stamp: 'dik 14.2.08 21:41'!
subject: anObject 
	subject := anObject! !

Object subclass: #Specification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

Specification subclass: #ComplexSpecification
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

ComplexSpecification subclass: #BehaviorSpec
	instanceVariableNames: 'activeSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
activeSpec
	^activeSpec! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
activeSpec: aComplexSpecification 
	activeSpec := aComplexSpecification! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
arbitrarilyUsedSpecs
	^contents select: [:eachSpec | eachSpec isArbitraryUsage]! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
checkValidity
	self isValid ifFalse: [SpecFailed raiseWith: MessageSendNotHappen new]! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
existsActiveSpec
	^activeSpec notNil 
		and: [activeSpec isValid not and: [activeSpec isArbitraryUsage not]]! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isArbitraryUsage
	^false! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isValid
	^contents allSatisfy: [:eachSpec | eachSpec isValid]! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
reset
	super reset.
	self resetActiveSpec! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
resetActiveSpec
	activeSpec := nil! !

!BehaviorSpec methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
selectNotValidSpecs
	^self selectNotValidSpecsFrom: self stronglyUsedSpecs! !

!BehaviorSpec methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
selectNotValidSpecsFrom: innerSpecs 
	self subclassResponsibility! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
stronglyUsedSpecs
	^contents reject: [:eachSpec | eachSpec isArbitraryUsage]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: aMessageSend 
	| validation validation2 |
	validation := self validateByStronglyUsedSpecs: aMessageSend.
	validation isSuccess ifTrue: [^validation].
	validation2 := self validateByArbitrarilyUsedSpecs: aMessageSend.
	validation2 isSuccess ifTrue: [^validation2].
	validation class = TooManyMessageSends ifFalse: [^validation].
	^validation2! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validateByArbitrarilyUsedSpecs: aMessageSend 
	| validation |
	self arbitrarilyUsedSpecs do: 
			[:eachSpec | 
			validation := eachSpec validate: aMessageSend.
			validation isSuccess ifTrue: [^validation]].
	^validation ifNil: [^TooManyMessageSends for: aMessageSend]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validateByStronglyUsedSpecs: aMessageSend 
	| notValidSpecs validateState |
	self existsActiveSpec ifTrue: [^activeSpec validate: aMessageSend].
	notValidSpecs := self selectNotValidSpecs.
	notValidSpecs isEmpty ifTrue: [^TooManyMessageSends for: aMessageSend].
	notValidSpecs do: 
			[:eachSpec | 
			validateState := eachSpec validate: aMessageSend.
			validateState isSuccess 
				ifTrue: 
					[activeSpec := eachSpec.
					^validateState]].
	^notValidSpecs first validate: aMessageSend! !

BehaviorSpec subclass: #LenientBehaviorSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!LenientBehaviorSpec methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
selectNotValidSpecsFrom: innerSpecs 
	^innerSpecs reject: [:eachSpec | eachSpec isValid]! !

BehaviorSpec subclass: #StrictBehaviorSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!StrictBehaviorSpec methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
selectNotValidSpecsFrom: innerSpecs 
	^Array 
		with: (innerSpecs detect: [:eachSpec | eachSpec isValid not] ifNone: [^#()])! !

ComplexSpecification subclass: #ComplexMessageUsageSpec
	instanceVariableNames: 'isValid isArbitrary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!ComplexMessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
beArbitrary
	isArbitrary := true! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
hasArbitraryUsageSpec
	^contents anySatisfy: [:eachUsageSpec | eachUsageSpec isArbitrary]! !

!ComplexMessageUsageSpec methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:38'!
initialize
	super initialize.
	isArbitrary := false.
	self reset! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isArbitrary
	isArbitrary ifFalse: [^self hasArbitraryUsageSpec].
	^isArbitrary! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isValid
	contents isEmpty ifTrue: [^isValid | isArbitrary].
	^contents allSatisfy: [:eachUsageSpec | eachUsageSpec isValid]! !

!ComplexMessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
reset
	super reset.
	isValid := false! !

!ComplexMessageUsageSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: aMessageSend 
	| validation |
	contents isEmpty 
		ifTrue: 
			[isValid := true.
			^BehaviorSpecValidationSuccess for: aMessageSend].
	contents do: 
			[:eachUsageSpec | 
			validation := eachUsageSpec validate: aMessageSend.
			validation isFailing ifTrue: [^validation]].
	contents do: [:eachUsageSpec | eachUsageSpec incrementUsageCount].
	^BehaviorSpecValidationSuccess for: aMessageSend! !

!ComplexSpecification class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
new
	^super new initialize! !

!ComplexSpecification methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
add: aSpecification 
	contents add: aSpecification! !

!ComplexSpecification methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
contents
	^contents! !

!ComplexSpecification methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:38'!
initialize
	contents := OrderedCollection new! !

!ComplexSpecification methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isArbitraryUsage
	self subclassResponsibility! !

!ComplexSpecification methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isEmpty
	^contents isEmpty! !

!ComplexSpecification methodsFor: 'private' stamp: 'dik 14.2.08 21:38'!
reset
	contents do: [:eachSpec | eachSpec reset]! !

ComplexSpecification subclass: #MessageSendSpec
	instanceVariableNames: 'actions usageSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MessageSendSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
withMessageSemanticsLike: aMessageSend 
	^self new add: (MessageSemanticsSpec from: aMessageSend)! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
actions
	^actions! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
actions: aMockActionSequence 
	actions := aMockActionSequence! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
addAction: aMockAction 
	actions add: aMockAction! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
addUsageSpec: aMessageUsageSpec 
	usageSpec add: aMessageUsageSpec! !

!MessageSendSpec methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:38'!
initialize
	super initialize.
	actions := MockActionSequence new.
	usageSpec := ComplexMessageUsageSpec new! !

!MessageSendSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isArbitraryUsage
	^usageSpec isArbitrary! !

!MessageSendSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isValid
	^usageSpec isValid! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
reset
	usageSpec reset.
	actions reset! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
usageSpec
	^usageSpec! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
usageSpec: aComplexMessageUsageSpec 
	usageSpec := aComplexMessageUsageSpec! !

!MessageSendSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: aMessageSend 
	| validationState |
	contents do: 
			[:eachSpec | 
			validationState := eachSpec validate: aMessageSend.
			validationState isFailing ifTrue: [^validationState]].
	validationState := usageSpec validate: aMessageSend.
	validationState isFailing ifTrue: [^validationState].
	^BehaviorSpecValidationSuccess for: aMessageSend withActions: actions! !

Specification subclass: #GeneralBehaviorSpec
	instanceVariableNames: 'definitionBlock type validation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!GeneralBehaviorSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
definedBy: specDefinitionBlock as: aBehaviorSpecClass 
	^self 
		definedBy: specDefinitionBlock
		as: aBehaviorSpecClass
		validatedBy: (SpecValidation in: thisContext)! !

!GeneralBehaviorSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
definedBy: specDefinitionBlock as: aBehaviorSpecClass validatedBy: aSpecValidation 
	^(self new)
		definitionBlock: specDefinitionBlock;
		type: aBehaviorSpecClass;
		validation: aSpecValidation! !

!GeneralBehaviorSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
definedBy: specDefinitionBlock as: aBehaviorSpecClass with: anExceptionClass 
	^self 
		definedBy: specDefinitionBlock
		as: aBehaviorSpecClass
		validatedBy: (SpecValidation with: anExceptionClass in: thisContext)! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
definitionBlock
	^definitionBlock! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
definitionBlock: anObject
	definitionBlock := anObject! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
denial: aBoolean 
	validation denial: aBoolean! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
title: aString 
	validation title: aString! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
type
	^type! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
type: anObject
	type := anObject! !

!GeneralBehaviorSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: behaviorBlock 
	definitionBlock define: type.
	validation runFor: behaviorBlock.
	^StateValidationSuccess new! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
validation
	^validation! !

!GeneralBehaviorSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
validation: anObject
	validation := anObject! !

Specification subclass: #MessageContextSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

MessageContextSpec subclass: #AsynchronousCallSpec
	instanceVariableNames: 'initialProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-ContextSpecs'!

!AsynchronousCallSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
forCurrentProcess
	^self new initialProcess: Processor activeProcess! !

!AsynchronousCallSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
initialProcess
	^initialProcess! !

!AsynchronousCallSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
initialProcess: aProcess 
	initialProcess := aProcess! !

!AsynchronousCallSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: aMessageSend 
	^initialProcess == Processor activeProcess 
		ifTrue: [WrongProcess for: aMessageSend]
		ifFalse: [BehaviorSpecValidationSuccess for: aMessageSend]! !

MessageContextSpec subclass: #ConditionSpec
	instanceVariableNames: 'subjectBlock stateSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-ContextSpecs'!

!ConditionSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
subjectBlock: aBlock stateSpec: aStateSpec 
	^(self new)
		subjectBlock: aBlock;
		stateSpec: aStateSpec! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
stateSpec
	^stateSpec! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
stateSpec: aStateSpec 
	stateSpec := aStateSpec! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
subjectBlock
	^subjectBlock! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
subjectBlock: aBlock 
	subjectBlock := aBlock! !

!ConditionSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: aMessageSend 
	^stateSpec validate: subjectBlock value! !

!MessageContextSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:38'!
isUsageSpec
	^false! !

MessageContextSpec subclass: #MessageSemanticsSpec
	instanceVariableNames: 'receiver selector argumentConstraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
from: aMessageSend 
	^self 
		receiver: aMessageSend receiver
		selector: aMessageSend selector
		argumentConstraints: (aMessageSend arguments 
				collect: [:each | each asStateSpec])! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
receiver: anObject selector: aSymbol 
	^self 
		receiver: anObject
		selector: aSymbol
		argumentConstraints: Array new! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
receiver: anObject selector: aSymbol argumentConstraint: aConstraint 
	^(self new)
		receiver: anObject;
		selector: aSymbol;
		argumentConstraints: (Array with: aConstraint)! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
receiver: anObject selector: aSymbol argumentConstraints: anArray 
	^(self new)
		receiver: anObject;
		selector: aSymbol;
		argumentConstraints: anArray! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
argumentConstraints
	^argumentConstraints! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
argumentConstraints: anArray 
	argumentConstraints := anArray! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
receiver
	^receiver! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
receiver: anObject 
	receiver := anObject! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
selector
	^selector! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
selector: aSymbol 
	selector := aSymbol! !

!MessageSemanticsSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: aMessageSend 
	| state |
	receiver == aMessageSend receiver 
		ifFalse: 
			[^WrongMessageReceiver for: aMessageSend
				withExpectedReceiver: receiver].
	selector = aMessageSend selector 
		ifFalse: 
			[^WrongMessageSelector for: aMessageSend
				withExpectedSelector: selector].
	argumentConstraints with: aMessageSend arguments
		do: 
			[:myArg :hisArg | 
			state := myArg validate: hisArg.
			state isFailing 
				ifTrue: 
					[^WrongMessageArgument 
						for: aMessageSend
						index: (argumentConstraints indexOf: myArg)
						stateFailing: state]].
	^BehaviorSpecValidationSuccess for: aMessageSend! !

Specification subclass: #MessageUsageSpec
	instanceVariableNames: 'usageCount validatedUsageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-UsageSpecs'!

MessageUsageSpec subclass: #LimitedUsageSpec
	instanceVariableNames: 'usageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-UsageSpecs'!

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
singleUsage
	^self withExactUsageCount: 1! !

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
withExactUsageCount: anInteger 
	^self withUsageCountBetween: anInteger and: anInteger! !

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
withUsageCountBetween: min and: max 
	^(self withValidatedUsageLimit: min) usageLimit: max! !

!LimitedUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
usageLimit
	^usageLimit! !

!LimitedUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
usageLimit: anInteger 
	usageLimit := anInteger! !

!LimitedUsageSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: aMessageSend 
	usageCount < usageLimit ifTrue: [^BehaviorSpecValidationSuccess for: aMessageSend].
	^UsageLimitExceeded for: aMessageSend withUsageLimit: validatedUsageLimit! !

!MessageUsageSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
new
	^super new initialize! !

!MessageUsageSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
withValidatedUsageLimit: anInteger 
	^self new validatedUsageLimit: anInteger! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
incrementUsageCount
	usageCount := usageCount + 1! !

!MessageUsageSpec methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:39'!
initialize
	self reset! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
isArbitrary
	^usageCount > 0! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
isUsageSpec
	^true! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
isValid
	^usageCount >= validatedUsageLimit! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
reset
	usageCount := 0! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
usageCount
	^usageCount! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
usageCount: anInteger 
	usageCount := anInteger! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
validatedUsageLimit
	^validatedUsageLimit! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
validatedUsageLimit: anInteger 
	validatedUsageLimit := anInteger! !

MessageUsageSpec subclass: #UnlimitedUsageSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-UsageSpecs'!

!UnlimitedUsageSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: aMessageSend 
	^BehaviorSpecValidationSuccess for: aMessageSend! !

!Specification methodsFor: 'validation' stamp: 'dik 14.2.08 21:38'!
validate: aMessageSend 
	self subclassResponsibility! !

Specification subclass: #StateSpec
	instanceVariableNames: 'denial title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

StateSpec subclass: #ArbitraryStateSpec
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!ArbitraryStateSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
from: aBlockContext 
	^self new condition: aBlockContext! !

!ArbitraryStateSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^condition value: anObject! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
condition
	^condition! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
condition: aBlockContext 
	condition := aBlockContext! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dk 8/20/2007 10:46'!
debugValidationFailingOver: aSpecFailed
	"
	[SSpecDSLAcceptanceTests new customTestForArbitraryBlock] fork
	"
	| mainProcess |
	mainProcess := Processor activeProcess.
	[
	mainProcess 
		completeTo: aSpecFailed signalContext sender sender sender; 
		restartTop;	
		stepToHome: condition asContext;
		debug] forkAt: mainProcess priority.
	mainProcess suspend! !

!ArbitraryStateSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'satisfy: ' , condition stringForSpecValidation! !

StateSpec subclass: #ComplexStateSpec
	instanceVariableNames: 'patterns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

ComplexStateSpec subclass: #All
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!All methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isFailing ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

ComplexStateSpec subclass: #Any
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!Any class methodsFor: 'converting' stamp: 'dik 14.2.08 21:39'!
asStateSpec
	^self! !

!Any class methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
denial: aBoolean 
	^self! !

!Any class methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject 
	^StateValidationSuccess new! !

!Any methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isSuccess ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

!ComplexStateSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
of: arrayOfPatterns 
	^self new patterns: (arrayOfPatterns collect: [:each | each asStateSpec])! !

!ComplexStateSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
of: pattern1 and: pattern2 
	^self of: (Array with: pattern1 with: pattern2)! !

!ComplexStateSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
of: pattern1 and: pattern2 and: pattern3 
	^self of: (Array 
				with: pattern1
				with: pattern2
				with: pattern3)! !

!ComplexStateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
patterns
	^patterns! !

!ComplexStateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
patterns: anArray
	patterns := anArray! !

!ComplexStateSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject by: aConstraint 
	^aConstraint
		denial: denial;
		validate: anObject! !

ComplexStateSpec subclass: #Nothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!Nothing class methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
denial
	^true! !

!Nothing methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:39'!
initialize
	super initialize.
	denial := true! !

!Nothing methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isFailing ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

StateSpec subclass: #ContainmentSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

ContainmentSpec subclass: #ElementContainmentSpec
	instanceVariableNames: 'requiredElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!ElementContainmentSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
requiredElement: anObject 
	^self new requiredElement: anObject! !

!ElementContainmentSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aCollection 
	^aCollection includes: requiredElement! !

!ElementContainmentSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'include ' , requiredElement printString! !

!ElementContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredElement
	^requiredElement! !

!ElementContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredElement: anObject
	requiredElement := anObject! !

ContainmentSpec subclass: #IndexContainmentSpec
	instanceVariableNames: 'requiredIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!IndexContainmentSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
requiredIndex: anObject 
	^self new requiredIndex: anObject! !

!IndexContainmentSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aCollection 
	^requiredIndex between: 1 and: aCollection size! !

!IndexContainmentSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'include index ' , requiredIndex printString! !

!IndexContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredIndex
	^requiredIndex! !

!IndexContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredIndex: anInteger
	requiredIndex := anInteger! !

ContainmentSpec subclass: #KeyContainmentSpec
	instanceVariableNames: 'requiredKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!KeyContainmentSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
requiredKey: anObject 
	^self new requiredKey: anObject! !

!KeyContainmentSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aCollection 
	^aCollection includesKey: requiredKey! !

!KeyContainmentSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'include key ' , requiredKey printString! !

!KeyContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredKey
	^requiredKey! !

!KeyContainmentSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredKey: anObject 
	requiredKey := anObject! !

StateSpec subclass: #ElementsCountSpec
	instanceVariableNames: 'requiredValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!ElementsCountSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
requiredValue: anInteger 
	^self new requiredValue: anInteger! !

!ElementsCountSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aCollection 
	^aCollection size = requiredValue! !

!ElementsCountSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'have ' , requiredValue printString , ' elements'! !

!ElementsCountSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredValue
	^requiredValue! !

!ElementsCountSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredValue: anInteger 
	requiredValue := anInteger! !

StateSpec subclass: #ObjectComparisonSpec
	instanceVariableNames: 'pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

ObjectComparisonSpec subclass: #EqualitySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!EqualitySpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^pattern = anObject! !

!EqualitySpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	^'equal'! !

ObjectComparisonSpec subclass: #FloatingComparisonSpec
	instanceVariableNames: 'accuracy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!FloatingComparisonSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
pattern: aNumber accuracy: aNumber2 
	^(self pattern: aNumber) accuracy: aNumber2! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
accuracy
	^accuracy! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
accuracy: anObject
	accuracy := anObject! !

!FloatingComparisonSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aNumber 
	^aNumber isEqual: pattern within: accuracy! !

!FloatingComparisonSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'be within ' , accuracy printString , ' of ' , pattern printString! !

ObjectComparisonSpec subclass: #IdentitySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!IdentitySpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^pattern == anObject! !

!IdentitySpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	^'be'! !

!ObjectComparisonSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
pattern: anObject 
	^self new pattern: anObject! !

!ObjectComparisonSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	self subclassResponsibility! !

!ObjectComparisonSpec methodsFor: 'displaying' stamp: 'dik 6/15/2010 13:29'!
defaultTitle
	^self clauseKeyword , ' ' , pattern stringForSpecTitle ! !

!ObjectComparisonSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
pattern
	^pattern! !

!ObjectComparisonSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
pattern: anObject 
	pattern := anObject! !

StateSpec subclass: #ObjectRelationshipSpec
	instanceVariableNames: 'requiredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

ObjectRelationshipSpec subclass: #ClassSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!ClassSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^anObject class = requiredClass! !

!ClassSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	^'be an instance of'! !

ObjectRelationshipSpec subclass: #HierarchySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!HierarchySpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^anObject isKindOf: requiredClass! !

!HierarchySpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	^'be a kind of'! !

!ObjectRelationshipSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
for: aClass 
	^self new requiredClass: aClass! !

!ObjectRelationshipSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
clauseKeyword
	self subclassResponsibility! !

!ObjectRelationshipSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^self clauseKeyword , ' ' , requiredClass name! !

!ObjectRelationshipSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredClass
	^requiredClass! !

!ObjectRelationshipSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredClass: aClass 
	requiredClass := aClass! !

StateSpec subclass: #RaisingExceptionSpec
	instanceVariableNames: 'requiredException'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!RaisingExceptionSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
requiredException: anExceptionClass 
	^self new requiredException: anExceptionClass! !

!RaisingExceptionSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: aBlockContext 
	^
	[aBlockContext value.
	false] on: requiredException
			do: 
				[:ex | 
				ex class = SpecFailed ifTrue: [ex outer].
				ex return: true]! !

!RaisingExceptionSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'raise ' , requiredException name! !

!RaisingExceptionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredException
	^requiredException! !

!RaisingExceptionSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
requiredException: anExceptionClass 
	requiredException := anExceptionClass! !

StateSpec subclass: #ResponsibilitySpec
	instanceVariableNames: 'messageSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-StateSpecs'!

!ResponsibilitySpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
for: aSelector 
	^self new messageSelector: aSelector! !

!ResponsibilitySpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	^anObject respondsTo: messageSelector! !

!ResponsibilitySpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'respond to ' , messageSelector printString! !

!ResponsibilitySpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
messageSelector
	^messageSelector! !

!ResponsibilitySpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
messageSelector: aSymbol 
	messageSelector := aSymbol! !

!StateSpec class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:39'!
new
	^super new initialize! !

!StateSpec methodsFor: 'specs composition' stamp: 'dik 2/17/2008 21:43'!
& aStateSpec 
	^All of: self and: aStateSpec! !

!StateSpec methodsFor: 'converting' stamp: 'dik 14.2.08 21:39'!
asStateSpec
	^self! !

!StateSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
basicMatches: anObject 
	self subclassResponsibility! !

!StateSpec methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:38'!
debugValidationFailingOver: aSpecFailed
	UnhandledError signalForException: aSpecFailed! !

!StateSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
defaultTitle
	^'satisfy for ' , self printString! !

!StateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
denial
	^denial! !

!StateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
denial: aBoolean 
	denial := aBoolean! !

!StateSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
description
	^self shouldPrefixPhrase , ' ' , self title! !

!StateSpec methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:39'!
initialize
	denial := false! !

!StateSpec methodsFor: 'testing' stamp: 'dik 14.2.08 21:39'!
matches: anObject 
	^(self basicMatches: anObject) ~= denial! !

!StateSpec methodsFor: 'specs composition' stamp: 'dik 14.2.08 21:39'!
not
	^Nothing of: (Array with: self)! !

!StateSpec methodsFor: 'displaying' stamp: 'dik 14.2.08 21:39'!
shouldPrefixPhrase
	^'should' , (denial ifTrue: [' not'] ifFalse: [''])! !

!StateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
title
	^title ifNil: [title := self defaultTitle]! !

!StateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:39'!
title: aString 
	title := aString! !

!StateSpec methodsFor: 'accessing' stamp: 'dik 14.2.08 21:41'!
titleFrom: aSyntaxPath 
	self title: aSyntaxPath printSpecTitle! !

!StateSpec methodsFor: 'validation' stamp: 'dik 14.2.08 21:39'!
validate: anObject 
	(self matches: anObject) ifTrue: [^StateValidationSuccess new].
	^StateValidationFailing spec: self for: anObject! !

!StateSpec methodsFor: 'specs composition' stamp: 'dik 2/17/2008 21:43'!
| aStateSpec 
	^Any of: self and: aStateSpec! !

Object subclass: #SpecificationHandler
	instanceVariableNames: 'spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

SpecificationHandler subclass: #BehaviorSpecHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

BehaviorSpecHandler subclass: #BehaviorSpecBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!BehaviorSpecBuilder methodsFor: 'evaluation' stamp: 'dik 14.2.08 21:38'!
evaluateMessageSend: aMessageSend 
	| messageSendSpec |
	messageSendSpec := MessageSendSpec withMessageSemanticsLike: aMessageSend.
	spec add: messageSendSpec.
	^MessageSendSpecBuilder on: messageSendSpec! !

!BehaviorSpecHandler methodsFor: 'evaluation' stamp: 'dik 14.2.08 21:38'!
evaluateMessageSend: aMessageSend
	self subclassResponsibility! !

BehaviorSpecHandler subclass: #MessageSendValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MessageSendValidator methodsFor: 'evaluation' stamp: 'dik 14.2.08 21:38'!
evaluateMessageSend: aMessageSend 
	^(spec validate: aMessageSend) raise! !

SpecificationHandler subclass: #MessageSendSpecBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-Core'!

!MessageSendSpecBuilder methodsFor: 'context specs definition' stamp: 'dik 14.2.08 21:39'!
shouldBeAsynchronous
	spec add: AsynchronousCallSpec forCurrentProcess! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useArbitrarily
	spec usageSpec beArbitrary! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useAtLeast: anInteger 
	spec addUsageSpec: (UnlimitedUsageSpec withValidatedUsageLimit: anInteger)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useAtLeast: min atMost: max 
	spec addUsageSpec: (LimitedUsageSpec withUsageCountBetween: min and: max)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useAtMost: anInteger 
	self useAtLeast: 1 atMost: anInteger! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useExactly: anInteger 
	spec addUsageSpec: (LimitedUsageSpec withExactUsageCount: anInteger)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useOnce
	self useExactly: 1! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dik 14.2.08 21:39'!
useTwice
	self useExactly: 2! !

!MessageSendSpecBuilder methodsFor: 'context specs definition' stamp: 'dik 14.2.08 21:39'!
when: aBlock is: aStateSpec 
	spec 
		add: (ConditionSpec subjectBlock: aBlock stateSpec: aStateSpec asStateSpec)! !

!MessageSendSpecBuilder methodsFor: 'context specs definition' stamp: 'dik 14.2.08 21:39'!
when: aBlock satisfy: oneArgBlock 
	self when: aBlock is: (ArbitraryStateSpec from: oneArgBlock)! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dik 14.2.08 21:40'!
will: anObject 
	spec addAction: anObject asMockAction! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dik 14.2.08 21:40'!
willRaise: anExceptionClass 
	self will: (RaisingException of: anExceptionClass)! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dik 14.2.08 21:40'!
willReturn: anObject 
	self will: (ReturnValue of: anObject)! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dik 14.2.08 21:40'!
willReturnYourself
	self will: ReturnReceiver new! !

!SpecificationHandler class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:38'!
on: aSpec 
	^self new spec: aSpec! !

!SpecificationHandler methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec
	^spec! !

!SpecificationHandler methodsFor: 'accessing' stamp: 'dik 14.2.08 21:38'!
spec: aSpec 
	spec := aSpec! !

Object subclass: #SyntaxDriver
	instanceVariableNames: 'targetPragmas progress currentMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SyntaxSugar'!

!SyntaxDriver class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
new
	^super new initialize! !

!SyntaxDriver class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
on: arrayOfPragmas 
	^self new targetPragmas: arrayOfPragmas! !

!SyntaxDriver methodsFor: 'controlling' stamp: 'dik 14.2.08 21:40'!
acceptMessage: aMessage 
	currentMessage := aMessage.
	progress := progress + 1.
	self filterTargetPragmas! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
clause
	^targetPragmas first clause! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
createTarget
	^self targetPragma createInstanceWith: currentMessage arguments! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
currentMessage
	^currentMessage! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
currentMessage: anObject
	currentMessage := anObject! !

!SyntaxDriver methodsFor: 'private' stamp: 'dik 2/17/2008 20:11'!
filterTargetPragmas
	| matchesPragmas |
	matchesPragmas := targetPragmas select: 
					[:each | 
					each clause size >= progress 
						and: [(each clause at: progress) = currentMessage selector]].
	matchesPragmas isEmpty ifTrue: [UnexpectedMessage signal].
	targetPragmas := matchesPragmas! !

!SyntaxDriver methodsFor: 'initialize-release' stamp: 'dik 14.2.08 21:40'!
initialize
	progress := 0! !

!SyntaxDriver methodsFor: 'testing' stamp: 'dik 14.2.08 21:40'!
isClauseComplete
	targetPragmas size > 1 ifTrue: [^false].
	^progress = targetPragmas first clause size! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
path
	^SyntaxPath clause: self targetPragma clause
		arguments: currentMessage arguments! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
progress
	^progress! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
progress: anObject
	progress := anObject! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
targetPragma
	^targetPragmas first! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
targetPragmas
	^targetPragmas! !

!SyntaxDriver methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
targetPragmas: arrayOfPragmas 
	targetPragmas := arrayOfPragmas! !

Object subclass: #SyntaxHelper
	instanceVariableNames: 'driver targetRecipient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SyntaxSugar'!

!SyntaxHelper class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
supplyingTargetsFrom: aClass to: aSyntaxTargetRecipient 
	^(self new)
		targetRecipient: aSyntaxTargetRecipient;
		driver: (SyntaxDriver on: aClass syntaxPragmas)! !

!SyntaxHelper methodsFor: 'dispatching' stamp: 'dik 14.2.08 21:40'!
doesNotUnderstand: aMessage 
	driver acceptMessage: aMessage.
	driver isClauseComplete ifFalse: [^self].
	targetRecipient receive: driver createTarget createdBy: driver path! !

!SyntaxHelper methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
driver
	^driver! !

!SyntaxHelper methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
driver: aSyntaxDriver 
	driver := aSyntaxDriver! !

!SyntaxHelper methodsFor: 'dispatching' stamp: 'dik 2/17/2008 21:19'!
error
	^self doesNotUnderstand: (Message selector: #error)! !

!SyntaxHelper methodsFor: 'helpers' stamp: 'dik 14.2.08 21:41'!
not
	targetRecipient changeNegation! !

!SyntaxHelper methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
targetRecipient
	^targetRecipient! !

!SyntaxHelper methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
targetRecipient: aRecipient 
	targetRecipient := aRecipient! !

Object subclass: #SyntaxPath
	instanceVariableNames: 'clause arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mocketry-SyntaxSugar'!

!SyntaxPath class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
allAt: sourceContext 
	| arguments pragmas |
	arguments := sourceContext arguments.
	pragmas := Pragma allSyntaxInMethod: sourceContext method.
	^pragmas 
		collect: [:each | SyntaxPath clause: each clause arguments: arguments]! !

!SyntaxPath class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
allAtHere
	^self allAt: thisContext sender! !

!SyntaxPath class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
anyAtHere
	^(self allAt: thisContext sender) first! !

!SyntaxPath class methodsFor: 'instance creation' stamp: 'dik 14.2.08 21:40'!
clause: selectorsArray arguments: argumentsArray 
	^(self new)
		clause: selectorsArray;
		arguments: argumentsArray! !

!SyntaxPath methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
arguments
	^arguments! !

!SyntaxPath methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
arguments: argumentsArray 
	arguments := argumentsArray! !

!SyntaxPath methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
clause
	^clause! !

!SyntaxPath methodsFor: 'accessing' stamp: 'dik 14.2.08 21:40'!
clause: selectorsArray 
	clause := selectorsArray! !

!SyntaxPath methodsFor: 'printing' stamp: 'dik 14.2.08 21:41'!
printSpecTitle
	| stream |
	stream := String new writeStream.
	(clause allButLast: 1) do: 
			[:eachPart | 
			stream
				nextPutAll: eachPart;
				nextPut: $ ].
	arguments isEmpty 
		ifTrue: 
			[stream nextPutAll: clause last.
			^stream contents].
	arguments with: clause last keywords
		do: 
			[:eachArg :eachKeyword | 
			stream
				nextPutAll: eachKeyword;
				skip: -1;
				nextPut: $ ;
				nextPutAll: eachArg stringForSpecTitle;
				nextPut: $ ].
	stream skip: -1.
	^stream contents! !
